(function(ns) {
    var _container = $('#trackPanel>#trackContainer'),
        _earth = null,
        _dataProcess = null,
        _seTrackMgr = null,
        _roleId = null,
        _trackId = null,
        _track=null;


    //main
    function _initTrack2(earth, dataProcess) {
        _earth = earth;
        _dataProcess = dataProcess

        _seTrackMgr = new ns.STAMP.SeTrackManager({
            earth: _earth,
            dataProcess: _dataProcess
        });

        _addEventListeners();
    }

    function _destroyTrack2() {
        
    }

    function _addEventListeners() {
        $('#trackPanel2').find('#create').bind('click', function(e) {
            _track = _seTrackMgr.createTrack({
                trackName: '新路径'
            }).track;
            

            _earth.Event.OnCreateGeometry = function(pFeat) {
                _earth.Event.OnCreateGeometry = function(pFeat) {};

                _earth.ShapeCreator.Clear();

                if (!pFeat) {
                    return;
                }
                if (pFeat.Count < 3) {
                    alert('路径点不能少于3个');
                    return;
                }

                var result = {
                    routeName: 'pass',
                    flyHeight: 50,
                    flySpeed: 10,
                    routeHeading: 0,
                    routeTilt: 0,
                    routeRate: 0.01
                };

                var route = _seTrackMgr.createRoute({
                    track: _track,
                    routeName: result.routeName,
                    pos: pFeat,
                    heading: result.routeHeading,
                    tile: result.routeTilt,
                    rate: result.routeRate,
                    params: [{
                        flyHeight: result.flyHeight,
                        flySpeed: result.flySpeed
                    }]
                });

                _track.Visibility = true;
            }
            _earth.ShapeCreator.CreatePolyline(2, 0xffff0000);
        });



        $('#trackPanel2').find('#trackPlay').bind('click', function(e) {
            if(!_track){
                return;
            }

            try {
                _seTrackMgr.getDynamicObject({
                    onDynamicListLoaded: function(roles) {
                        for (var i = 0; i < roles.Count; i++) {
                            var dynamic = roles.Items(i);
                            var type = dynamic.Type;
                            if (type == "FlyObject"){
                                _roleId = dynamic.Guid
                                _seTrackMgr.loadDynamicObject({
                                    dynamicId: _roleId,
                                    onDynamicLoaded: function(options) {
                                        var did = options.id;
                                        var type = options.type;
                                        if (type != 2) {
                                            return;
                                        }

                                        _seTrackMgr.playTrack({
                                            track: _track,
                                            dynamicId: _roleId,
                                            trackType: 3,
                                            mode: 2,
                                            smooth: false,
                                            onTrackFinish: function(options) {
                                                var tid = options.tId;
                                                var did = options.dId;

                                                _seTrackMgr.unloadDynamicObject({
                                                    dynamicId: did
                                                });
                                            }
                                        });
                                    }
                                });
                                break;
                            }
                        }
                    }
                });
            } catch (e) {

            }
        });

        $('#trackPanel2').find('#trackStop').bind('click', function(e) {
            if(_track){
                _track.stop();
            }
        });
    }

    if (!ns.STAMP.initer) {
        ns.STAMP.initer = {};
    }
    ns.STAMP.initer.initTrack2 = _initTrack2;
    ns.STAMP.initer.destroyTrack2 = _destroyTrack2;
})(window);
